import { LinkedListNode } from './LinkedListNode';
declare type Node<T> = LinkedListNode<T> | undefined;
export declare class LinkedList<T> {
    length: number;
    private headN;
    private tailN;
    constructor(...values: T[]);
    add(val: T): LinkedListNode<T>;
    forEach<C>(f: ((value: LinkedListNode<T>) => void), ctx?: C): void;
    head(): Node<T>;
    pop(): T | undefined;
    remove(n: LinkedListNode<T>): void;
    shift(): T | undefined;
    tail(): Node<T>;
}
export {};
